diff --git gcc/testsuite/gcc.dg/graphite/id-1.c gcc/testsuite/gcc.dg/graphite/id-1.c
index 70b477a..1085c4a 100644
--- gcc/testsuite/gcc.dg/graphite/id-1.c
+++ gcc/testsuite/gcc.dg/graphite/id-1.c
@@ -1,5 +1,6 @@
 typedef int *lambda_vector;
 typedef lambda_vector *lambda_matrix;
+void
 lambda_vector_add_mc (lambda_vector vec1, int const1,
 		      lambda_vector vec2, int const2,
 		      lambda_vector vec3, int size)
@@ -8,6 +9,7 @@ lambda_vector_add_mc (lambda_vector vec1, int const1,
   for (i = 0; i < size; i++)
     vec3[i] = const1 * vec1[i] + const2 * vec2[i];
 }
+void
 lambda_matrix_add_mc (lambda_matrix mat1, int const1,
 		      lambda_matrix mat2, int const2,
 		      lambda_matrix mat3, int m, int n)
diff --git gcc/testsuite/gcc.dg/graphite/id-13.c gcc/testsuite/gcc.dg/graphite/id-13.c
index e921cd4..0dfafb8 100644
--- gcc/testsuite/gcc.dg/graphite/id-13.c
+++ gcc/testsuite/gcc.dg/graphite/id-13.c
@@ -1,3 +1,5 @@
+void bar (int);
+
 void
 foo (int N, int k, int *fb)
 {
diff --git gcc/testsuite/gcc.dg/graphite/id-17.c gcc/testsuite/gcc.dg/graphite/id-17.c
index c93c211..68a7bb5 100644
--- gcc/testsuite/gcc.dg/graphite/id-17.c
+++ gcc/testsuite/gcc.dg/graphite/id-17.c
@@ -11,6 +11,7 @@ typedef struct
 } ImageParameters;
 
 ImageParameters *img;
+void error (const char *);
 
 void GenerateSequenceParameterSet(seq_parameter_set_rbsp_t *sps)
 {
diff --git gcc/testsuite/gcc.dg/graphite/id-2.c gcc/testsuite/gcc.dg/graphite/id-2.c
index c11f6a2..c416822 100644
--- gcc/testsuite/gcc.dg/graphite/id-2.c
+++ gcc/testsuite/gcc.dg/graphite/id-2.c
@@ -1,4 +1,5 @@
 typedef _Complex float GFC_COMPLEX_4;
+void
 matmul_c4 ()
 {
   int x, n, count;
diff --git gcc/testsuite/gcc.dg/graphite/id-23.c gcc/testsuite/gcc.dg/graphite/id-23.c
index 0f8a1f3..3b62d91 100644
--- gcc/testsuite/gcc.dg/graphite/id-23.c
+++ gcc/testsuite/gcc.dg/graphite/id-23.c
@@ -1,3 +1,4 @@
+void SubMtx_blockDiagonalInfo (int **);
 double *ZV_entries (void);
 void SubMtx_fillRowZV (int irow)
 {
diff --git gcc/testsuite/gcc.dg/graphite/id-26.c gcc/testsuite/gcc.dg/graphite/id-26.c
index 507d159..e6f64e5 100644
--- gcc/testsuite/gcc.dg/graphite/id-26.c
+++ gcc/testsuite/gcc.dg/graphite/id-26.c
@@ -1,3 +1,4 @@
+int abs (int);
 int find_sad_16x16(int *intra_mode)
 {
   int current_intra_sad_2,best_intra_sad2;
diff --git gcc/testsuite/gcc.dg/graphite/id-4.c gcc/testsuite/gcc.dg/graphite/id-4.c
index 38f6738..71d4b17 100644
--- gcc/testsuite/gcc.dg/graphite/id-4.c
+++ gcc/testsuite/gcc.dg/graphite/id-4.c
@@ -1,4 +1,5 @@
-extern a[];
+extern int a[];
+void
 g ()
 {
   int i, b;
diff --git gcc/testsuite/gcc.dg/graphite/id-8.c gcc/testsuite/gcc.dg/graphite/id-8.c
index 1a278c1..25405cf 100644
--- gcc/testsuite/gcc.dg/graphite/id-8.c
+++ gcc/testsuite/gcc.dg/graphite/id-8.c
@@ -1,4 +1,5 @@
 int blah;
+int
 foo()
 {
   int i;
diff --git gcc/testsuite/gcc.dg/graphite/id-pr43464-1.c gcc/testsuite/gcc.dg/graphite/id-pr43464-1.c
index d5a8359..8e6ac20 100644
--- gcc/testsuite/gcc.dg/graphite/id-pr43464-1.c
+++ gcc/testsuite/gcc.dg/graphite/id-pr43464-1.c
@@ -3,6 +3,7 @@ typedef struct regnode
   char flags;
 } regnode;
 extern const unsigned char A[];
+int bar (regnode *);
 
 char *foo (regnode *c, char *s, int norun)
 {
diff --git gcc/testsuite/gcc.dg/graphite/id-pr43464.c gcc/testsuite/gcc.dg/graphite/id-pr43464.c
index a8e67dc..b9cf7c8 100644
--- gcc/testsuite/gcc.dg/graphite/id-pr43464.c
+++ gcc/testsuite/gcc.dg/graphite/id-pr43464.c
@@ -13,6 +13,9 @@ typedef struct cop
 extern const unsigned char PL_utf8skip[];
 extern char PL_dowarn;
 extern COP *volatile PL_curcop;
+int S_reginclass (regnode *);
+int S_regtry (regexp *, char *);
+unsigned long Perl_utf8n_to_uvuni (char *, int, long unsigned int *, int);
 char *
 S_find_byclass (regexp * prog, regnode * c, char *s, char *strend,
 		char *startpos, int norun)
@@ -49,15 +52,18 @@ S_find_byclass (regexp * prog, regnode * c, char *s, char *strend,
 got_it:
   return s;
 }
+void
 Perl_re_intuit_start (regexp * prog)
 {
   S_find_byclass (prog, 0, 0, 0, 0, 1);
 }
+void
 Perl_regexec_flags (register regexp * prog,
 		    register char *strend)
 {
   S_find_byclass (prog, 0, 0, strend, 0, 0);
 }
+int
 S_regtry (regexp * prog, char *startpos)
 {
 }
diff --git gcc/testsuite/gcc.dg/graphite/id-pr45230-1.c gcc/testsuite/gcc.dg/graphite/id-pr45230-1.c
index ba14fe5..427e9a6 100644
--- gcc/testsuite/gcc.dg/graphite/id-pr45230-1.c
+++ gcc/testsuite/gcc.dg/graphite/id-pr45230-1.c
@@ -41,6 +41,7 @@ test (const unsigned char *s1, const unsigned char *s2, size_t len, int expected
     __builtin_abort ();
 }
 
+int
 main ()
 {
   size_t off1, off2, len, i;
diff --git gcc/testsuite/gcc.dg/graphite/id-pr45230.c gcc/testsuite/gcc.dg/graphite/id-pr45230.c
index 80f6769..8ebf804 100644
--- gcc/testsuite/gcc.dg/graphite/id-pr45230.c
+++ gcc/testsuite/gcc.dg/graphite/id-pr45230.c
@@ -1,4 +1,5 @@
 unsigned char buf[10];
+int
 main ()
 {
   unsigned off1, len, i;
diff --git gcc/testsuite/gcc.dg/graphite/id-pr45231.c gcc/testsuite/gcc.dg/graphite/id-pr45231.c
index 01e9a67..d976e32 100644
--- gcc/testsuite/gcc.dg/graphite/id-pr45231.c
+++ gcc/testsuite/gcc.dg/graphite/id-pr45231.c
@@ -1,5 +1,5 @@
 void
-f (n, ppt, xrot)
+f (int n, int ppt, int xrot)
 {
   int tileWidth;
   int nlwSrc;
diff --git gcc/testsuite/gcc.dg/graphite/pr37485.c gcc/testsuite/gcc.dg/graphite/pr37485.c
index 7432aaa..09a2b66 100644
--- gcc/testsuite/gcc.dg/graphite/pr37485.c
+++ gcc/testsuite/gcc.dg/graphite/pr37485.c
@@ -3,6 +3,8 @@
 typedef unsigned char   UChar;
 typedef int             Int32;
 typedef unsigned int    UInt32;
+void VPrintf0(const char *);
+void AssertH (int, int);
 
 void fallbackSort ( UInt32* fmap, 
                     UInt32* eclass, 
diff --git gcc/testsuite/gcc.dg/graphite/pr38073.c gcc/testsuite/gcc.dg/graphite/pr38073.c
index 9c48d8d..a68b9e2 100644
--- gcc/testsuite/gcc.dg/graphite/pr38073.c
+++ gcc/testsuite/gcc.dg/graphite/pr38073.c
@@ -1,5 +1,6 @@
 /* { dg-options "-O3 -fgraphite-identity" } */
 
+int
 test_seg(int a, int b)
 {
   int i,r=1;
diff --git gcc/testsuite/gcc.dg/graphite/pr38125.c gcc/testsuite/gcc.dg/graphite/pr38125.c
index 780e6f6..3075c19 100644
--- gcc/testsuite/gcc.dg/graphite/pr38125.c
+++ gcc/testsuite/gcc.dg/graphite/pr38125.c
@@ -22,6 +22,7 @@ struct magic {
     TEST_SV* mg_obj;
 };
 extern TEST_SV PL_sv_undef;
+void
 Perl_av_fill( register TEST_AV *av, int fill)
 {
     TEST_MAGIC *mg;
diff --git gcc/testsuite/gcc.dg/graphite/pr38409.c gcc/testsuite/gcc.dg/graphite/pr38409.c
index 5cdb472..d308b5e 100644
--- gcc/testsuite/gcc.dg/graphite/pr38409.c
+++ gcc/testsuite/gcc.dg/graphite/pr38409.c
@@ -6,6 +6,7 @@ struct test
   int type ;
   int symflag ;
 };
+int
 Chv_copyEntriesToVector ( input *chv,double *dvec) 
 {
   double *entries ;
diff --git gcc/testsuite/gcc.dg/graphite/pr38413.c gcc/testsuite/gcc.dg/graphite/pr38413.c
index 6c2b23a..0ecccc7 100644
--- gcc/testsuite/gcc.dg/graphite/pr38413.c
+++ gcc/testsuite/gcc.dg/graphite/pr38413.c
@@ -3,6 +3,7 @@
 static int qsz;
 
 void specqsort(base, n, size, compar)
+     int n, size, compar;
      char *base;
 {
   register char c, *i, *j, *lo, *hi;
diff --git gcc/testsuite/gcc.dg/graphite/pr38500.c gcc/testsuite/gcc.dg/graphite/pr38500.c
index f5292d1..f6b4215 100644
--- gcc/testsuite/gcc.dg/graphite/pr38500.c
+++ gcc/testsuite/gcc.dg/graphite/pr38500.c
@@ -4,6 +4,7 @@ typedef unsigned char U8;
 extern char test1;
 
 char *Perl_screaminstr (int, int, int);
+int Perl_utf8_distance (U8 *, U8 *);
 
 void
 Perl_re_intuit_start( int minlen,  char *strend, unsigned int flags, int i)
diff --git gcc/testsuite/gcc.dg/graphite/pr38510.c gcc/testsuite/gcc.dg/graphite/pr38510.c
index 07ddb6e..8c7fcae 100644
--- gcc/testsuite/gcc.dg/graphite/pr38510.c
+++ gcc/testsuite/gcc.dg/graphite/pr38510.c
@@ -3,6 +3,7 @@ typedef long int integer;
 typedef double doublereal;
 
 static int balanc_(nm, n, a, low, igh, scale)
+int nm, n, low, igh, scale;
 doublereal *a;
 {
  integer a_dim1, a_offset, i__1, i__2;
diff --git gcc/testsuite/gcc.dg/graphite/pr38786.c gcc/testsuite/gcc.dg/graphite/pr38786.c
index 47df447..6c619dd 100644
--- gcc/testsuite/gcc.dg/graphite/pr38786.c
+++ gcc/testsuite/gcc.dg/graphite/pr38786.c
@@ -10,6 +10,7 @@ typedef struct
 } RD_DATA;
 extern RD_DATA *rdopt;
 extern ImageParameters *img;
+void
 dummy_slice_too_big (int bits_slice)
 {
   int i, j, k, l;
diff --git gcc/testsuite/gcc.dg/graphite/pr39260.c gcc/testsuite/gcc.dg/graphite/pr39260.c
index 066b5bd..74977ea 100644
--- gcc/testsuite/gcc.dg/graphite/pr39260.c
+++ gcc/testsuite/gcc.dg/graphite/pr39260.c
@@ -1,5 +1,6 @@
 /* { dg-options "-O2 -fgraphite-identity -ffast-math" } */
 
+void
 VBR_encode_frame (int mode_gr, int channels_out, int max_bits[2][2])
 {
  int max_nbits_ch[2][2];
diff --git gcc/testsuite/gcc.dg/graphite/pr42284.c gcc/testsuite/gcc.dg/graphite/pr42284.c
index 854c251..41f9a45 100644
--- gcc/testsuite/gcc.dg/graphite/pr42284.c
+++ gcc/testsuite/gcc.dg/graphite/pr42284.c
@@ -1,5 +1,7 @@
 /* { dg-options "-O2 -fgraphite-identity" } */
 
+int foo (void);
+
 int
 huft_build (unsigned *b)
 {
diff --git gcc/testsuite/gcc.dg/graphite/pr42914.c gcc/testsuite/gcc.dg/graphite/pr42914.c
index 606ee08..9f79611 100644
--- gcc/testsuite/gcc.dg/graphite/pr42914.c
+++ gcc/testsuite/gcc.dg/graphite/pr42914.c
@@ -1,5 +1,7 @@
 /* { dg-options "-O2 -g -ffast-math -fgraphite-identity" } */
 
+int abs (int);
+
 int find_sad_16x16(int *mode)
 {
   int current, best;
diff --git gcc/testsuite/gcc.dg/graphite/pr46404-1.c gcc/testsuite/gcc.dg/graphite/pr46404-1.c
index c3e620c..a3f404a2 100644
--- gcc/testsuite/gcc.dg/graphite/pr46404-1.c
+++ gcc/testsuite/gcc.dg/graphite/pr46404-1.c
@@ -1,5 +1,7 @@
 /* { dg-options "-O -fgraphite-identity -fno-tree-scev-cprop" } */
 
+int foo (void);
+
 int
 huft_build (unsigned *b)
 {
diff --git gcc/testsuite/gcc.dg/graphite/pr60979.c gcc/testsuite/gcc.dg/graphite/pr60979.c
index 0004a51..66fffa5 100644
--- gcc/testsuite/gcc.dg/graphite/pr60979.c
+++ gcc/testsuite/gcc.dg/graphite/pr60979.c
@@ -5,6 +5,7 @@
 struct x;
 
 typedef struct x **(*a)(struct x *);
+void d (const char *);
 
 struct x {
     union {
diff --git gcc/testsuite/gcc.dg/graphite/scop-19.c gcc/testsuite/gcc.dg/graphite/scop-19.c
index cfbf401..9dfc865 100644
--- gcc/testsuite/gcc.dg/graphite/scop-19.c
+++ gcc/testsuite/gcc.dg/graphite/scop-19.c
@@ -15,6 +15,7 @@ struct d_growable_string
 {
   size_t alc;
 };
+void
 d_growable_string_resize (struct d_growable_string *dgs, size_t need)
 {
   size_t newalc;
@@ -22,6 +23,7 @@ d_growable_string_resize (struct d_growable_string *dgs, size_t need)
   while (newalc < need)
     newalc <<= 1;
 }
+void
 d_growable_string_append_buffer (struct d_growable_string *dgs,
                                  const char *s, size_t l)
 {